


<script>

export default {

	data () {
		/*
			// const buffer = new ArrayBuffer (8);
		*/
		
		var uint_8_array = new Uint8Array (57);
		
		return {
			input: 0,
			// max: BigInt (Math.pow (16, 144) - 1),
			
			max: BigInt ([
				"0x",
				"FFFFFFFFFFFFFFFF",
				"FFFFFFFFFFFFFFFF",
				"FFFFFFFFFFFFFFFF",
				"FFFFFFFFFFFFFFFF",
				"FFFFFFFFFFFFFFFF",
				"FFFFFFFFFFFFFFFF",
				"FFFFFFFFFFFFFFFF",
				"FFFFFFFFFFFFFFFF",
				"FFFFFFFFFFFFFFFF"
			].join ("")),
			
			/* max: BigInt ([
				"1860707134196753639806268948193291",
				"6079453218833595342343206149099024",
				"3657757029868371504908982723472783",
				"555205531204141550984858016925351935"
			].join ("")), */
			
			// 16 ** 114
			uint_8_array
		}
	},
	
	watch: {
		input (input) {
			console.log ('input changed', { input })
			
			console.log (typeof input)
			
			var big_int = BigInt (parseFloat (input))
			console.log ({ big_int })
			console.log (big_int.toString (16))
		}
	},
	
	methods: {
		to16String (integer) {
			var amount = parseInt (integer).toString (16);
			
			if (amount.length === 1) {
				amount = "0" + amount;
			}
			
			return amount.toUpperCase ();
		},
		modify (index) {
			console.log ({ index })
		},
		
		deliver () {
			console.log ('deliver')
		}
	}
}

</script>

<template>
	<main>
		<h1>Elliptic Key Production</h1>

		<p>Javascript Number.MAX_VALUE = {{ Number.MAX_VALUE }}</p>
		
		<p :style="{ wordWrap: 'break-word' }">ED448 Seed Max Value = {{ max }}</p>
		
		<p
			:style="{ wordWrap: 'break-word' }"
		>ED448 Seed Max Value = {{ parseInt (max) }}</p>
		
		<div />
		
		<button>generate</button>
		
		<div />
		
			{{ input }}
		
		
		<div />
			<input 
				:style="{ width: '100%' }"
				
				type="range"
				v-model="input"
				
				min="0"
				:max="max"
			/>
		<div />

		{{ uint_8_array.length }}
	
		<div :style="{ height: '20px' }"/>
	
		<div
			v-for="(entry, index) in uint_8_array"
			:style="{
				display: 'inline-block',
				padding: '0 2px'
			}"
		>
			{{ to16String (entry) }}
		</div>	
		
		<div :style="{ height: '20px' }"/>
		
		<div
			v-for="(entry, index) in uint_8_array"
			:style="{
				display: 'inline-block',
				padding: '0 2px'
			}"
		>
			<input 
				:value="to16String (entry)"
				@keyup="modify (index)"
			/>
			
			{{ to16String (entry) }}
		</div>
		
		
		<div />
		

	</main>
</template>
